#include "tp2.h"

/*********************************
 * Linear congruential generator
 *********************************/

// global variables
static long unsigned LCG_state = 1;
static long unsigned LCG_a = 1103515245;
static long unsigned LCG_c = 12345;
static long unsigned LCG_m = 1lu<<31;

// initialize the current LCG
void LCG_init(long unsigned a, long unsigned c, long unsigned m) {
    LCG_a = a;
    LCG_c = c;
    LCG_m = m;
}

// give the initial seed for the current LCG
void LCG_seed(long unsigned seed) {
    LCG_state = seed;
}

// generate the next number
long unsigned LCG_random() {
    LCG_state = (LCG_state*LCG_a + LCG_c)% LCG_m;
    return LCG_state;
}

// display the current LCG
void LCG_show() {
    printf("\n");
    printf("x_n = %ld.x_n-1 + %ld  (mod %ld)\n", LCG_a, LCG_c, LCG_m);
    /* printf("current state: 0x%lx\n", LCG_state); */
}

// look for the period of the current LCG with given seed
// TODO
int LCG_period(unsigned long seed);
