/*
 * info-528,
 * fonctions diverses pour le TP2
 */
#include "tp2.h"

/*
 * affiche un entier long en binaire
 */
void print_bin(unsigned long m, int t) {
    for (int i=0;i<t;i++) {
        printf("%lu ",BIT(t-1-i,m));
    }
}

/*
 * calcule le pgcd et les nombres de Bezout pour a et b
 * (les autres arguments sont utilisés pour renvoyer le résultat)
 */
void pgcd_bezout (long* g, long* x, long* y, long a, long b) {
    long xx = 0; long old_x = 1;
    long yy = 1; long old_y = 0;
    long rr = b; long  old_r = a;
    long q, tmp;
    while (rr != 0) {
        q = old_r / rr;
        tmp = rr; rr = old_r - q * tmp; old_r = tmp;
        tmp = xx; xx = old_x - q * tmp; old_x = tmp;
        tmp = yy; yy = old_y - q * tmp; old_y = tmp;
    }
    if (old_r<0) {*g = -old_r;} else {*g = old_r;}
    *x = old_x; *y = old_y;
    if (-*g == a**x + b**y) {*x = -*x; *y = -*y;}
    assert (*g>0);
    assert (a * *x + b * *y == *g);
}

/*
 * calcul le pgcd de a et b
 */
long pgcd(long a, long b) {
    long g,x,y;
    pgcd_bezout(&g,&x,&y,a,b);
    return g;
}


